--- libmp3lame/fft.c.orig	2009-04-21 06:48:00.000000000 +0900
+++ libmp3lame/fft.c	2011-10-16 02:38:59.000000000 +0900
@@ -38,6 +38,12 @@
 # include <config.h>
 #endif
 
+#ifdef ALTIVEC
+#ifndef __APPLE_CC__
+#include <altivec.h>
+#endif
+#endif
+
 #include "lame.h"
 #include "machine.h"
 #include "encoder.h"
@@ -67,6 +73,17 @@
     int     k4;
     FLOAT  *fi, *gi;
     FLOAT const *fn;
+#ifdef ALTIVEC
+    float csvec[16] __attribute__ ((aligned (16)));
+    vector float v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16;
+    vector float vfi0,vfi1,vfi2,vfi3,vgi0,vgi1,vgi2,vgi3,vf0,vf1,vf2,vf3,vg0,vg1,vg2,vg3;
+    vector float vprev1,vprev2,vprev3,vprev4,vc1,vc2,vs1,vs2,vzero;
+    vector unsigned char vperm1,vperm2;
+    
+    vperm1 = (vector unsigned char)VINIT16(16,17,18,19,12,13,14,15,8,9,10,11,4,5,6,7);
+    vperm2 = (vector unsigned char)VINIT16(16,17,18,19,4,5,6,7,8,9,10,11,12,13,14,15);
+    vzero = vec_xor(vzero,vzero);
+#endif
 
     n <<= 1;            /* to get BLKSIZE, because of 3DNow! ASM routine */
     fn = fz + n;
@@ -104,6 +121,238 @@
         } while (fi < fn);
         c1 = tri[0];
         s1 = tri[1];
+#ifdef ALTIVEC
+        if(kx < 4) {
+            for (i = 1; i < kx; i++) {
+                FLOAT   c2, s2;
+                c2 = 1 - (2 * s1) * s1;
+                s2 = (2 * s1) * c1;
+                fi = fz + i;
+                gi = fz + k1 - i;
+                do {
+                    FLOAT   a, b, g0, f0, f1, g1, f2, g2, f3, g3;
+                    b = s2 * fi[k1] - c2 * gi[k1];
+                    a = c2 * fi[k1] + s2 * gi[k1];
+                    f1 = fi[0] - a;
+                    f0 = fi[0] + a;
+                    g1 = gi[0] - b;
+                    g0 = gi[0] + b;
+                    b = s2 * fi[k3] - c2 * gi[k3];
+                    a = c2 * fi[k3] + s2 * gi[k3];
+                    f3 = fi[k2] - a;
+                    f2 = fi[k2] + a;
+                    g3 = gi[k2] - b;
+                    g2 = gi[k2] + b;
+                    b = s1 * f2 - c1 * g3;
+                    a = c1 * f2 + s1 * g3;
+                    fi[k2] = f0 - a;
+                    fi[0] = f0 + a;
+                    gi[k3] = g1 - b;
+                    gi[k1] = g1 + b;
+                    b = c1 * g2 - s1 * f3;
+                    a = s1 * g2 + c1 * f3;
+                    gi[k2] = g0 - a;
+                    gi[0] = g0 + a;
+                    fi[k3] = f1 - b;
+                    fi[k1] = f1 + b;
+                    gi += k4;
+                    fi += k4;
+                } while (fi < fn);
+                c2 = c1;
+                c1 = c2 * tri[0] - s1 * tri[1];
+                s1 = c2 * tri[1] + s1 * tri[0];
+            }
+        }
+        else {
+            FLOAT   c2, s2;
+            for(i = 1; i < 4; i++) {
+                c2 = 1 - (2*s1)*s1;
+                s2 = (2*s1)*c1;
+                csvec[i] = c1;
+                csvec[i+4] = c2;
+                csvec[i+8] = s1;
+                csvec[i+12] = s2;
+                c2 = c1;
+                c1 = c2 * tri[0] - s1 * tri[1];
+                s1 = c2 * tri[1] + s1 * tri[0];
+            }
+            vc1 = vec_ld(0,csvec);
+            vc2 = vec_ld(16,csvec);
+            vs1 = vec_ld(32,csvec);
+            vs2 = vec_ld(48,csvec);
+            fi = fz;
+            gi = fz + k1;
+            do {
+                vfi0 = vec_ld(0,fi);
+                vfi1 = vec_ld(0,fi+k1);
+                vfi2 = vec_ld(0,fi+k2);
+                vfi3 = vec_ld(0,fi+k3);
+                vprev1 = vec_ld(0,gi-4);
+                vprev2 = vec_ld(0,gi+k1-4);
+                vprev3 = vec_ld(0,gi+k2-4);
+                vprev4 = vec_ld(0,gi+k3-4);
+                vgi0 = vec_perm(vprev1,vprev1,vperm1);
+                vgi1 = vec_perm(vprev2,vprev2,vperm1);
+                vgi2 = vec_perm(vprev3,vprev3,vperm1);
+                vgi3 = vec_perm(vprev4,vprev4,vperm1);
+                
+                v1 = vec_madd(vfi1,vc2,vzero);
+                v2 = vec_madd(vfi1,vs2,vzero);
+                v3 = vec_madd(vfi3,vc2,vzero);
+                v4 = vec_madd(vfi3,vs2,vzero);
+                v5 = vec_madd(vgi1,vs2,v1);
+                v6 = vec_nmsub(vgi1,vc2,v2);
+                v7 = vec_madd(vgi3,vs2,v3);
+                v8 = vec_nmsub(vgi3,vc2,v4);
+                
+                vf0 = vec_add(vfi0,v5);
+                vf1 = vec_sub(vfi0,v5);
+                vg0 = vec_add(vgi0,v6);
+                vg1 = vec_sub(vgi0,v6);
+                vf2 = vec_add(vfi2,v7);
+                vf3 = vec_sub(vfi2,v7);
+                vg2 = vec_add(vgi2,v8);
+                vg3 = vec_sub(vgi2,v8);
+                
+                v1 = vec_madd(vf2,vc1,vzero);
+                v2 = vec_madd(vf2,vs1,vzero);
+                v3 = vec_madd(vg2,vs1,vzero);
+                v4 = vec_madd(vg2,vc1,vzero);
+                v5 = vec_madd(vg3,vs1,v1);
+                v6 = vec_nmsub(vg3,vc1,v2);
+                v7 = vec_madd(vf3,vc1,v3);
+                v8 = vec_nmsub(vf3,vs1,v4);
+                
+                v9 = vec_add(vf0,v5);
+                v10 = vec_sub(vf0,v5);
+                v11 = vec_add(vg1,v6);
+                v12 = vec_sub(vg1,v6);
+                v13 = vec_add(vg0,v7);
+                v14 = vec_sub(vg0,v7);
+                v15 = vec_add(vf1,v8);
+                v16 = vec_sub(vf1,v8);
+                
+                v1 = vec_perm(v9,vfi0,vperm2);
+                v2 = vec_perm(v10,vfi2,vperm2);
+                v3 = vec_perm(v15,vfi1,vperm2);
+                v4 = vec_perm(v16,vfi3,vperm2);
+                vec_st(v1,0,fi);
+                vec_st(v2,0,fi+k2);
+                vec_st(v3,0,fi+k1);
+                vec_st(v4,0,fi+k3);
+                
+                v1 = vec_perm(v11,vprev2,vperm1);
+                v2 = vec_perm(v12,vprev4,vperm1);
+                v3 = vec_perm(v13,vprev1,vperm1);
+                v4 = vec_perm(v14,vprev3,vperm1);
+                vec_st(v1,0,gi+k1-4);
+                vec_st(v2,0,gi+k3-4);
+                vec_st(v3,0,gi-4);
+                vec_st(v4,0,gi+k2-4);
+                
+                gi += k4;
+                fi += k4;
+            } while (fi<fn);
+            
+            /* rest loop */
+            
+            for (i = 4; i < kx; i+=4) {
+                int j;
+                for(j = 0; j < 4; j++) {
+                    c2 = 1 - (2*s1)*s1;
+                    s2 = (2*s1)*c1;
+                    csvec[j] = c1;
+                    csvec[j+4] = c2;
+                    csvec[j+8] = s1;
+                    csvec[j+12] = s2;
+                    c2 = c1;
+                    c1 = c2 * tri[0] - s1 * tri[1];
+                    s1 = c2 * tri[1] + s1 * tri[0];
+                }
+                vc1 = vec_ld(0,csvec);
+                vc2 = vec_ld(16,csvec);
+                vs1 = vec_ld(32,csvec);
+                vs2 = vec_ld(48,csvec);
+                fi = fz + i;
+                gi = fz + k1 - i;
+                do {
+                    vfi0 = vec_ld(0,fi);
+                    vfi1 = vec_ld(0,fi+k1);
+                    vfi2 = vec_ld(0,fi+k2);
+                    vfi3 = vec_ld(0,fi+k3);
+                    vprev1 = vec_ld(0,gi-4);
+                    v1 = vec_ld(0,gi);
+                    vprev2 = vec_ld(0,gi+k1-4);
+                    v2 = vec_ld(0,gi+k1);
+                    vprev3 = vec_ld(0,gi+k2-4);
+                    v3 = vec_ld(0,gi+k2);
+                    vprev4 = vec_ld(0,gi+k3-4);
+                    v4 = vec_ld(0,gi+k3);
+                    vgi0 = vec_perm(vprev1,v1,vperm1);
+                    vgi1 = vec_perm(vprev2,v2,vperm1);
+                    vgi2 = vec_perm(vprev3,v3,vperm1);
+                    vgi3 = vec_perm(vprev4,v4,vperm1);
+                    
+                    v1 = vec_madd(vfi1,vc2,vzero);
+                    v2 = vec_madd(vfi1,vs2,vzero);
+                    v3 = vec_madd(vfi3,vc2,vzero);
+                    v4 = vec_madd(vfi3,vs2,vzero);
+                    v5 = vec_madd(vgi1,vs2,v1);
+                    v6 = vec_nmsub(vgi1,vc2,v2);
+                    v7 = vec_madd(vgi3,vs2,v3);
+                    v8 = vec_nmsub(vgi3,vc2,v4);
+                    
+                    vf0 = vec_add(vfi0,v5);
+                    vf1 = vec_sub(vfi0,v5);
+                    vg0 = vec_add(vgi0,v6);
+                    vg1 = vec_sub(vgi0,v6);
+                    vf2 = vec_add(vfi2,v7);
+                    vf3 = vec_sub(vfi2,v7);
+                    vg2 = vec_add(vgi2,v8);
+                    vg3 = vec_sub(vgi2,v8);
+                    
+                    v1 = vec_madd(vf2,vc1,vzero);
+                    v2 = vec_madd(vf2,vs1,vzero);
+                    v3 = vec_madd(vg2,vs1,vzero);
+                    v4 = vec_madd(vg2,vc1,vzero);
+                    v5 = vec_madd(vg3,vs1,v1);
+                    v6 = vec_nmsub(vg3,vc1,v2);
+                    v7 = vec_madd(vf3,vc1,v3);
+                    v8 = vec_nmsub(vf3,vs1,v4);
+                    
+                    v9 = vec_add(vf0,v5);
+                    v10 = vec_sub(vf0,v5);
+                    v11 = vec_add(vg1,v6);
+                    v12 = vec_sub(vg1,v6);
+                    v13 = vec_add(vg0,v7);
+                    v14 = vec_sub(vg0,v7);
+                    v15 = vec_add(vf1,v8);
+                    v16 = vec_sub(vf1,v8);
+                    
+                    vec_st(v9,0,fi);
+                    vec_st(v10,0,fi+k2);
+                    vec_st(v15,0,fi+k1);
+                    vec_st(v16,0,fi+k3);
+                    
+                    v1 = vec_perm(v11,vprev2,vperm1);
+                    v2 = vec_perm(v12,vprev4,vperm1);
+                    v3 = vec_perm(v13,vprev1,vperm1);
+                    v4 = vec_perm(v14,vprev3,vperm1);
+                    vec_st(v1,0,gi+k1-4);
+                    vec_ste(v11,0,gi+k1);
+                    vec_st(v2,0,gi+k3-4);
+                    vec_ste(v12,0,gi+k3);
+                    vec_st(v3,0,gi-4);
+                    vec_ste(v13,0,gi);
+                    vec_st(v4,0,gi+k2-4);
+                    vec_ste(v14,0,gi+k2);
+                    
+                    gi += k4;
+                    fi += k4;
+                } while (fi<fn);
+            }
+        }
+#else
         for (i = 1; i < kx; i++) {
             FLOAT   c2, s2;
             c2 = 1 - (2 * s1) * s1;
@@ -143,6 +392,7 @@
             c1 = c2 * tri[0] - s1 * tri[1];
             s1 = c2 * tri[1] + s1 * tri[0];
         }
+#endif
         tri += 2;
     } while (k4 < n);
 }
--- libmp3lame/gain_analysis.c.orig	2008-08-05 04:53:56.000000000 +0900
+++ libmp3lame/gain_analysis.c	2011-10-30 18:54:08.000000000 +0900
@@ -92,6 +92,12 @@
 #include <config.h>
 #endif
 
+#ifdef ALTIVEC
+#ifndef __APPLE_CC__
+#include <altivec.h>
+#endif
+#endif
+
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
@@ -108,64 +114,64 @@
 #endif
 
 /*lint -save -e736 loss of precision */
-static const Float_t ABYule[9][2 * YULE_ORDER + 1] = {
+static const Float_t ABYule[9][2 * YULE_ORDER + 1 + 3] __attribute__ ((aligned (16))) = {
     {0.03857599435200, -3.84664617118067, -0.02160367184185, 7.81501653005538, -0.00123395316851,
      -11.34170355132042, -0.00009291677959, 13.05504219327545, -0.01655260341619,
      -12.28759895145294, 0.02161526843274, 9.48293806319790, -0.02074045215285, -5.87257861775999,
      0.00594298065125, 2.75465861874613, 0.00306428023191, -0.86984376593551, 0.00012025322027,
-     0.13919314567432, 0.00288463683916},
+     0.13919314567432, 0.00288463683916, 0.0, 0.0, 0.0},
     {0.05418656406430, -3.47845948550071, -0.02911007808948, 6.36317777566148, -0.00848709379851,
      -8.54751527471874, -0.00851165645469, 9.47693607801280, -0.00834990904936, -8.81498681370155,
      0.02245293253339, 6.85401540936998, -0.02596338512915, -4.39470996079559, 0.01624864962975,
      2.19611684890774, -0.00240879051584, -0.75104302451432, 0.00674613682247, 0.13149317958808,
-     -0.00187763777362},
+     -0.00187763777362, 0.0, 0.0, 0.0},
     {0.15457299681924, -2.37898834973084, -0.09331049056315, 2.84868151156327, -0.06247880153653,
      -2.64577170229825, 0.02163541888798, 2.23697657451713, -0.05588393329856, -1.67148153367602,
      0.04781476674921, 1.00595954808547, 0.00222312597743, -0.45953458054983, 0.03174092540049,
      0.16378164858596, -0.01390589421898, -0.05032077717131, 0.00651420667831, 0.02347897407020,
-     -0.00881362733839},
+     -0.00881362733839, 0.0, 0.0, 0.0},
     {0.30296907319327, -1.61273165137247, -0.22613988682123, 1.07977492259970, -0.08587323730772,
      -0.25656257754070, 0.03282930172664, -0.16276719120440, -0.00915702933434, -0.22638893773906,
      -0.02364141202522, 0.39120800788284, -0.00584456039913, -0.22138138954925, 0.06276101321749,
      0.04500235387352, -0.00000828086748, 0.02005851806501, 0.00205861885564, 0.00302439095741,
-     -0.02950134983287},
+     -0.02950134983287, 0.0, 0.0, 0.0},
     {0.33642304856132, -1.49858979367799, -0.25572241425570, 0.87350271418188, -0.11828570177555,
      0.12205022308084, 0.11921148675203, -0.80774944671438, -0.07834489609479, 0.47854794562326,
      -0.00469977914380, -0.12453458140019, -0.00589500224440, -0.04067510197014, 0.05724228140351,
      0.08333755284107, 0.00832043980773, -0.04237348025746, -0.01635381384540, 0.02977207319925,
-     -0.01760176568150},
+     -0.01760176568150, 0.0, 0.0, 0.0},
     {0.44915256608450, -0.62820619233671, -0.14351757464547, 0.29661783706366, -0.22784394429749,
      -0.37256372942400, -0.01419140100551, 0.00213767857124, 0.04078262797139, -0.42029820170918,
      -0.12398163381748, 0.22199650564824, 0.04097565135648, 0.00613424350682, 0.10478503600251,
      0.06747620744683, -0.01863887810927, 0.05784820375801, -0.03193428438915, 0.03222754072173,
-     0.00541907748707},
+     0.00541907748707, 0.0, 0.0, 0.0},
     {0.56619470757641, -1.04800335126349, -0.75464456939302, 0.29156311971249, 0.16242137742230,
      -0.26806001042947, 0.16744243493672, 0.00819999645858, -0.18901604199609, 0.45054734505008,
      0.30931782841830, -0.33032403314006, -0.27562961986224, 0.06739368333110, 0.00647310677246,
      -0.04784254229033, 0.08647503780351, 0.01639907836189, -0.03788984554840, 0.01807364323573,
-     -0.00588215443421},
+     -0.00588215443421, 0.0, 0.0, 0.0},
     {0.58100494960553, -0.51035327095184, -0.53174909058578, -0.31863563325245, -0.14289799034253,
      -0.20256413484477, 0.17520704835522, 0.14728154134330, 0.02377945217615, 0.38952639978999,
      0.15558449135573, -0.23313271880868, -0.25344790059353, -0.05246019024463, 0.01628462406333,
      -0.02505961724053, 0.06920467763959, 0.02442357316099, -0.03721611395801, 0.01818801111503,
-     -0.00749618797172},
+     -0.00749618797172, 0.0, 0.0, 0.0},
     {0.53648789255105, -0.25049871956020, -0.42163034350696, -0.43193942311114, -0.00275953611929,
      -0.03424681017675, 0.04267842219415, -0.04678328784242, -0.10214864179676, 0.26408300200955,
      0.14590772289388, 0.15113130533216, -0.02459864859345, -0.17556493366449, -0.11202315195388,
      -0.18823009262115, -0.04060034127000, 0.05477720428674, 0.04788665548180, 0.04704409688120,
-     -0.02217936801134}
+     -0.02217936801134, 0.0, 0.0, 0.0}
 };
 
-static const Float_t ABButter[9][2 * BUTTER_ORDER + 1] = {
-    {0.98621192462708, -1.97223372919527, -1.97242384925416, 0.97261396931306, 0.98621192462708},
-    {0.98500175787242, -1.96977855582618, -1.97000351574484, 0.97022847566350, 0.98500175787242},
-    {0.97938932735214, -1.95835380975398, -1.95877865470428, 0.95920349965459, 0.97938932735214},
-    {0.97531843204928, -1.95002759149878, -1.95063686409857, 0.95124613669835, 0.97531843204928},
-    {0.97316523498161, -1.94561023566527, -1.94633046996323, 0.94705070426118, 0.97316523498161},
-    {0.96454515552826, -1.92783286977036, -1.92909031105652, 0.93034775234268, 0.96454515552826},
-    {0.96009142950541, -1.91858953033784, -1.92018285901082, 0.92177618768381, 0.96009142950541},
-    {0.95856916599601, -1.91542108074780, -1.91713833199203, 0.91885558323625, 0.95856916599601},
-    {0.94597685600279, -1.88903307939452, -1.89195371200558, 0.89487434461664, 0.94597685600279}
+static const Float_t ABButter[9][2 * BUTTER_ORDER + 1 + 3] __attribute__ ((aligned (16))) = {
+    {0.98621192462708, -1.97223372919527, -1.97242384925416, 0.97261396931306, 0.98621192462708, 0.0, 0.0, 0.0},
+    {0.98500175787242, -1.96977855582618, -1.97000351574484, 0.97022847566350, 0.98500175787242, 0.0, 0.0, 0.0},
+    {0.97938932735214, -1.95835380975398, -1.95877865470428, 0.95920349965459, 0.97938932735214, 0.0, 0.0, 0.0},
+    {0.97531843204928, -1.95002759149878, -1.95063686409857, 0.95124613669835, 0.97531843204928, 0.0, 0.0, 0.0},
+    {0.97316523498161, -1.94561023566527, -1.94633046996323, 0.94705070426118, 0.97316523498161, 0.0, 0.0, 0.0},
+    {0.96454515552826, -1.92783286977036, -1.92909031105652, 0.93034775234268, 0.96454515552826, 0.0, 0.0, 0.0},
+    {0.96009142950541, -1.91858953033784, -1.92018285901082, 0.92177618768381, 0.96009142950541, 0.0, 0.0, 0.0},
+    {0.95856916599601, -1.91542108074780, -1.91713833199203, 0.91885558323625, 0.95856916599601, 0.0, 0.0, 0.0},
+    {0.94597685600279, -1.88903307939452, -1.89195371200558, 0.89487434461664, 0.94597685600279, 0.0, 0.0, 0.0}
 };
 
 /*lint -restore */
@@ -176,6 +182,191 @@
 
 /* When calling this procedure, make sure that ip[-order] and op[-order] point to real data! */
 
+#ifdef ALTIVEC
+
+static void
+filterIntegrated (const Float_t* input, Float_t* output, Float_t* output2, size_t nSamples, const Float_t* kernel, const Float_t* kernel2)
+{
+	vector float v1,v2,v3,v4,v5,v6,vbase;
+	vector float vmask1,vmask2,vout1,vout2,vout3,vout4,vzero,vkernel1,vkernel2,vkernel3,vkernel4,vkernel5,vkernel6,vkernel7,vkernel8;
+	vector float vo1, vo2, vo3, vo4, vi2, vi3;
+	vector unsigned char vc1,vc2,vc3,vc4,vc5,vperm1,vperm2,vperm4,vperm5,vperm6;
+	
+	vbase = (vector float)VINIT4ALL(1e-10f);
+	vperm1 = (vector unsigned char)VINIT16(24,25,26,27,16,17,18,19,8,9,10,11,0,1,2,3);
+	vperm2 = (vector unsigned char)VINIT16(28,29,30,31,20,21,22,23,12,13,14,15,4,5,6,7);
+	vc1 = vec_splat_u8(1);
+	vc2 = vec_splat_u8(5);
+	vc3 = vec_sl(vc1,vc2);
+	vc4 = vec_sl(vc3,vc1);
+	vc5 = vec_or(vc3,vc4);
+	v1 = (vector float)vec_splat_s32(-1);
+	vmask1 = vec_sro(v1,vc3);
+	vmask2 = vec_sro(v1,vc4);
+	vzero = vec_xor(vzero,vzero);
+	
+	v1 = vec_ld(0,kernel);
+	v2 = vec_ld(16,kernel);
+	v3 = vec_ld(32,kernel);
+	v4 = vec_ld(48,kernel);
+	v5 = vec_ld(64,kernel);
+	v6 = vec_ld(80,kernel);
+	vkernel1 = vec_perm(v1,v2,vperm1);
+	vkernel2 = vec_perm(v1,v2,vperm2);
+	vkernel3 = vec_perm(v3,v4,vperm1);
+	vkernel4 = vec_perm(v3,v4,vperm2);
+	vkernel5 = vec_perm(v5,v6,vperm1);
+	vkernel6 = vec_perm(v5,v6,vperm2);
+	vkernel5 = vec_and(vkernel5,vmask1);
+	vkernel6 = vec_and(vkernel6,vmask2);
+	
+	v1 = vec_ld(0,kernel2);
+	v2 = vec_ld(16,kernel2);
+	vkernel7 = vec_perm(v1,v2,vperm1);
+	vkernel8 = vec_perm(v1,v2,vperm2);
+	vkernel7 = vec_and(vkernel7,vmask1);
+	vkernel8 = vec_and(vkernel8,vmask2);
+	
+	vperm4 = vec_lvsl(0,input-7);
+	vperm5 = vec_lvsl(0,output-4);
+	
+	v1 = vec_ld(15,input-7);
+	v2 = vec_ld(0,input-7);
+	v3 = vec_ld(0,input-10);
+	v4 = vec_ld(15,input-11);
+	vi2 = vec_perm(v2,v1,vperm4);
+	vi3 = vec_perm(v3,v4,vec_lvsl(0,input-10));
+	vi3 = vec_sro(vi3,vc3);
+	
+	v1 = vec_ld(15,output-4);
+	v2 = vec_ld(0,output-4);
+	v3 = vec_ld(0,output-8);
+	v4 = vec_ld(0,output-10);
+	v5 = vec_ld(15,output-10);
+	vo1 = vec_perm(v2,v1,vperm5);
+	vo2 = vec_perm(v3,v2,vperm5);
+	vo3 = vec_perm(v4,v5,vec_lvsl(0,output-10));
+	vo3 = vec_sro(vo3,vc4);
+	
+	v1 = vec_ld(15,output2-2);
+	v2 = vec_ld(0,output2-2);
+	vo4 = vec_perm(v2,v1,vec_lvsl(0,output2-2));
+	vo4 = vec_sro(vo4,vc4);
+	
+	vperm4 = vec_lvsl(0,input-3);
+	vperm5 = vec_lvsr(0,output);
+	
+	/* 1st loop */
+	v1 = vec_ld(15,input-3);
+	v3 = vec_ld(0,input-3);
+	v5 = vec_perm(v3,v1,vperm4);
+		
+	vout1 = vec_madd(v5,vkernel1,vbase);
+	vout2 = vec_madd(vo1,vkernel2,vbase);
+
+	vout1 = vec_madd(vi2,vkernel3,vout1);
+	vout2 = vec_madd(vo2,vkernel4,vout2);
+
+	vout1 = vec_madd(vi3,vkernel5,vout1);
+	vout2 = vec_madd(vo3,vkernel6,vout2);
+		
+	vi3 = vec_sld(vi3,vi2,4);
+	vi2 = vec_sld(vi2,v5,4);
+		
+	vout1 = vec_sub(vout1,vout2);
+	
+	v1 = vec_slo(vout1,vc3);
+	v2 = vec_slo(vout1,vc4);
+	v3 = vec_slo(vout1,vc5);
+	vout1 = vec_add(vout1,v1);
+	vout2 = vec_add(v2,v3);
+	vout1 = vec_add(vout1,vout2);
+		
+	vo3 = vec_sld(vo3,vo2,4);
+	vo2 = vec_sld(vo2,vo1,4);
+	vo1 = vec_sld(vo1,vout1,4);
+		
+	vout2 = vec_perm(vout1,vout1,vperm5);
+	vec_ste(vout2,0,output);
+		
+	++output;
+	++input;
+	--nSamples;
+	
+	while(nSamples--) {
+		vperm4 = vec_lvsl(0,input-3);
+		vperm5 = vec_lvsr(0,output);
+		vperm6 = vec_lvsr(0,output2);
+		
+		v1 = vec_ld(15,input-3);
+		v3 = vec_ld(0,input-3);
+		v5 = vec_perm(v3,v1,vperm4);
+		
+		vout1 = vec_madd(v5,vkernel1,vbase);
+		vout2 = vec_madd(vo1,vkernel2,vbase);
+
+		vout1 = vec_madd(vi2,vkernel3,vout1);
+		vout2 = vec_madd(vo2,vkernel4,vout2);
+
+		vout1 = vec_madd(vi3,vkernel5,vout1);
+		vout2 = vec_madd(vo3,vkernel6,vout2);
+		
+		vout3 = vec_nmsub(vo4,vkernel8,vzero);
+		vout4 = vec_madd(vo1,vkernel7,vout3);
+		
+		vi3 = vec_sld(vi3,vi2,4);
+		vi2 = vec_sld(vi2,v5,4);
+		
+		vout1 = vec_sub(vout1,vout2);
+		
+		v1 = vec_slo(vout1,vc3);
+		v2 = vec_slo(vout1,vc4);
+		v3 = vec_slo(vout1,vc5);
+		vout1 = vec_add(vout1,v1);
+		vout2 = vec_add(v2,v3);
+		vout1 = vec_add(vout1,vout2);
+		
+		vo3 = vec_sld(vo3,vo2,4);
+		vo2 = vec_sld(vo2,vo1,4);
+		vo1 = vec_sld(vo1,vout1,4);
+		
+		v4 = vec_slo(vout4,vc3);
+		v5 = vec_slo(vout4,vc4);
+		v6 = vec_slo(vout4,vc5);
+		vout4 = vec_add(vout4,v4);
+		vout3 = vec_add(v5,v6);
+		vout3 = vec_add(vout3,vout4);
+		
+		vo4 = vec_sld(vo4,vout3,4);
+		
+		vout2 = vec_perm(vout1,vout1,vperm5);
+		vout4 = vec_perm(vout3,vout3,vperm6);
+		vec_ste(vout2,0,output);
+		vec_ste(vout4,0,output2);
+		
+		++output;
+		++output2;
+		++input;
+	}
+	
+	vperm6 = vec_lvsr(0,output2);
+	
+	vout3 = vec_nmsub(vo4,vkernel8,vzero);
+	vout4 = vec_madd(vo1,vkernel7,vout3);
+	
+	v1 = vec_slo(vout4,vc3);
+	v2 = vec_slo(vout4,vc4);
+	v3 = vec_slo(vout4,vc5);
+	vout4 = vec_add(vout4,v1);
+	vout3 = vec_add(v2,v3);
+	vout3 = vec_add(vout3,vout4);
+	
+	vout4 = vec_perm(vout3,vout3,vperm6);
+	vec_ste(vout4,0,output2);
+}
+
+#else
+
 static void
 filterYule(const Float_t * input, Float_t * output, size_t nSamples, const Float_t * const kernel)
 {
@@ -226,7 +417,7 @@
     }
 }
 
-
+#endif
 
 static int ResetSampleFrequency(replaygain_t * rgData, long samplefreq);
 
@@ -367,6 +558,10 @@
             curright = right_samples + cursamplepos;
         }
 
+#ifdef ALTIVEC
+        filterIntegrated(curleft, rgData->lstep + rgData->totsamp, rgData->lout + rgData->totsamp, cursamples, ABYule[rgData->freqindex], ABButter[rgData->freqindex]);
+        filterIntegrated(curright, rgData->rstep + rgData->totsamp, rgData->rout + rgData->totsamp, cursamples, ABYule[rgData->freqindex], ABButter[rgData->freqindex]);
+#else
         YULE_FILTER(curleft, rgData->lstep + rgData->totsamp, cursamples,
                     ABYule[rgData->freqindex]);
         YULE_FILTER(curright, rgData->rstep + rgData->totsamp, cursamples,
@@ -376,6 +571,7 @@
                       ABButter[rgData->freqindex]);
         BUTTER_FILTER(rgData->rstep + rgData->totsamp, rgData->rout + rgData->totsamp, cursamples,
                       ABButter[rgData->freqindex]);
+#endif
 
         curleft = rgData->lout + rgData->totsamp; /* Get the squared values */
         curright = rgData->rout + rgData->totsamp;
--- libmp3lame/lame.c.orig	2011-10-19 06:51:20.000000000 +0900
+++ libmp3lame/lame.c	2011-11-06 03:06:39.000000000 +0900
@@ -30,6 +30,11 @@
 # include <config.h>
 #endif
 
+#ifdef ALTIVEC
+#ifndef __APPLE_CC__
+#include <altivec.h>
+#endif
+#endif
 
 #include "lame.h"
 #include "machine.h"
@@ -577,7 +582,12 @@
         gfc->CPU_features.SSE = 0;
         gfc->CPU_features.SSE2 = 0;
     }
-
+#ifdef ALTIVEC
+    /* turn off JAVA mode explicitly */
+    vector unsigned short vscr = vec_mfvscr();
+    vscr = vec_or(vscr,(vector unsigned short)VINIT8(0,0,0,0,0,0,1,0));
+    vec_mtvscr(vscr);
+#endif
 
     if (NULL == gfc->ATH)
         gfc->ATH = calloc(1, sizeof(ATH_t));
--- libmp3lame/machine.h.orig	2012-02-08 03:15:00.000000000 +0900
+++ libmp3lame/machine.h	2012-02-08 17:32:36.000000000 +0900
@@ -174,6 +174,24 @@
 
 #define NEQ(a,b) (!EQ(a,b))
 
+#ifdef ALTIVEC
+#ifdef __APPLE_CC__
+#define VINIT4(a,b,c,d)                          (a,b,c,d)
+#define VINIT8(a,b,c,d,e,f,g,h)                  (a,b,c,d,e,f,g,h)
+#define VINIT16(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p) (a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p)
+#define VINIT4ALL(a)                             (a,a,a,a)
+#define VINIT8ALL(a)                             (a,a,a,a,a,a,a,a)
+#define VINIT16ALL(a)                            (a,a,a,a,a,a,a,a,a,a,a,a,a,a,a,a)
+#else
+#define VINIT4(a,b,c,d)                          {a,b,c,d}
+#define VINIT8(a,b,c,d,e,f,g,h)                  {a,b,c,d,e,f,g,h}
+#define VINIT16(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p) {a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p}
+#define VINIT4ALL(a)                             {a,a,a,a}
+#define VINIT8ALL(a)                             {a,a,a,a,a,a,a,a}
+#define VINIT16ALL(a)                            {a,a,a,a,a,a,a,a,a,a,a,a,a,a,a,a}
+#endif
+#endif
+
 #endif
 
 #ifdef _MSC_VER
